package org.expeditee.actions;

import java.awt.Color;
import java.io.BufferedReader;
import java.io.InputStreamReader;

import org.expeditee.agents.WriteTree;
import org.expeditee.gui.DisplayIO;
import org.expeditee.gui.Frame;
import org.expeditee.gui.FrameGraphics;

public class IDE {
	public static void CompileClass() {
		Frame source = DisplayIO.getCurrentFrame();
		String title = source.getTitle().getTextNoList();
		String[] tokens = title.split(" ");
		String className = tokens[tokens.length - 1];
		String fileName = "expeditee/src/" + className + ".java";
		WriteTree wt = new WriteTree("java", fileName);
		if (wt.initialise(source)) {
			wt.setStartFrame(source);
			wt.run();
			try {
				Runtime.getRuntime().exec("javac -d expeditee/bin " + fileName);
				FrameGraphics.DisplayMessage("Compiled " + fileName, Color.darkGray);
			} catch (Exception e) {
				FrameGraphics.ErrorMessage("Could not compile class!");
			}
		} else {
			FrameGraphics.ErrorMessage("Could not initialise agent!");
		}
	}

	public static String getClassName(Frame source) {
		return source.getTitle().getTextNoList().trim();
		//String title = source.getTitle().getTextNoList();
		//String[] tokens = title.split(" ");
		//return tokens[tokens.length - 1];
	}

	public static void RunClass() {
		Frame source = DisplayIO.getCurrentFrame();
		String className = getClassName(source);
		try {
			Process p = Runtime.getRuntime().exec("java -cp expeditee/bin " + className);
			BufferedReader stdInput = new BufferedReader(new InputStreamReader(
					p.getInputStream()));
			BufferedReader stdError = new BufferedReader(new InputStreamReader(
					p.getErrorStream()));
			String message = "";
			while ((message = stdInput.readLine()) != null) {
				FrameGraphics.DisplayMessage(message);
			}
			while ((message = stdError.readLine()) != null) {
				FrameGraphics.ErrorMessage(message);
			}
		} catch (Exception e) {
			FrameGraphics.ErrorMessage("Could not run class!");
		}
	}
	
	public static void CompileAndRunClass() {
		CompileClass();
		RunClass();
	}
}
