package org.expeditee.stats;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import org.expeditee.io.Logger;

/**
 * This class is used to create all stats log files. Files are created with
 * filename: Date-Time.stat<br>
 * Where Date is in the format DDMMMYYYY and Time is in the format HHMM.
 * 
 * @author mrww1
 * 
 */
public class StatsLogger {

	private static String _filename = null;
	private static final String FRAMES_EDITED_FILENAME = "FramesEdited.stat";

	/**
	 * Sets the path on disk that the statlog files will be created in.
	 * 
	 * @param location
	 *            The path on disk to create the log files in.
	 */
	private static void Init() {
		if (!org.expeditee.gui.UserSettings.LogStats)
			return;

		File test = new File(org.expeditee.gui.FrameIO.STATISTICS_DIR);
		if (!test.exists())
			test.mkdir();

		_filename = Logger.EasyDateFormat("ddMMMyy-HHmm") + ".stat";
	}

	/**
	 * Writes the current stats to a file.
	 * 
	 */
	public static void WriteStatsFile() {
		if (!org.expeditee.gui.UserSettings.LogStats)
			return;

		Init();

		try {
			BufferedWriter writer = new BufferedWriter(new FileWriter(
					org.expeditee.gui.FrameIO.STATISTICS_DIR + _filename, true));
			writer.write(SessionStats.getCurrentStats());
			writer.newLine();

			writer.flush();
			writer.close();
			
			writer = new BufferedWriter(new FileWriter(
					org.expeditee.gui.FrameIO.STATISTICS_DIR + FRAMES_EDITED_FILENAME, true));
			writer.write(SessionStats.getFramesEdited());
			writer.newLine();

			writer.flush();
			writer.close();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}
	}
}
