package org.expeditee.gui;

import junit.framework.TestCase;

import org.junit.Test;

public class FrameIOTest extends TestCase {

	public void testIsValidFrameName() {
		assertTrue(FrameIO.isValidFrameName("a1"));
		assertTrue(FrameIO.isValidFrameName("a1c1"));
		assertFalse(FrameIO.isValidFrameName("1a1"));
		assertFalse(FrameIO.isValidFrameName("$a1"));
		assertFalse(FrameIO.isValidFrameName("aa"));
		assertFalse(FrameIO.isValidFrameName("a1.1"));
		assertFalse(FrameIO.isValidFrameName(null));
		assertFalse(FrameIO.isValidFrameName("1"));
		assertFalse(FrameIO.isValidFrameName("a"));
		assertFalse(FrameIO.isValidFrameName(""));
	}

	@Test
	public void testIsValidFramesetName() {
		assertTrue(FrameIO.IsValidFramesetName("a"));
		assertTrue(FrameIO.IsValidFramesetName("a1c"));
		assertFalse(FrameIO.IsValidFramesetName("1a"));
		assertFalse(FrameIO.IsValidFramesetName("$a"));
		assertFalse(FrameIO.IsValidFramesetName("a$"));
		assertFalse(FrameIO.IsValidFramesetName("a.a"));
		assertFalse(FrameIO.IsValidFramesetName(null));
		assertFalse(FrameIO.IsValidFramesetName("1"));
		assertFalse(FrameIO.isValidFrameName(""));
		assertFalse(FrameIO
				.IsValidFramesetName("abcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyz012345678901A"));

	}

	public void testConvertToFramesetName() {
		assertEquals(FrameIO.ConvertToValidFramesetName("a"), "a");
		assertEquals(FrameIO.ConvertToValidFramesetName("a b"), ("aB"));
		assertEquals(FrameIO.ConvertToValidFramesetName("1a"), ("A1a"));
		assertEquals(FrameIO.ConvertToValidFramesetName("$a"), ("A"));
		assertEquals(FrameIO.ConvertToValidFramesetName("a$"), ("a"));
		assertEquals(FrameIO.ConvertToValidFramesetName("a.a"), ("aA"));
		assertEquals(FrameIO.ConvertToValidFramesetName("1"), ("A1A"));
		assertEquals(
				FrameIO
						.ConvertToValidFramesetName("abcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyz01234567890123456789"),
				("abcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyz01234567890A"));

	}
	/*
	 * @Test(expected=RuntimeException.class) public void
	 * ConvertToFramesetNameException() {
	 * FrameIO.ConvertToValidFramesetName(null); }
	 * 
	 * @Test(expected=RuntimeException.class) public void
	 * ConvertToFramesetNameException2() {
	 * FrameIO.ConvertToValidFramesetName(""); }
	 */
}
